import datetime


ID_LOOKUP = {
    "10": {"id": "EELC", "name": "UK Power Networks"},
    "11": {"id": "EMEB", "name": "Western Power Distribution"},
    "12": {"id": "LOND", "name": "UK Power Networks"},
    "13": {"id": "MANW", "name": "SP Energy Networks"},
    "14": {"id": "MIDE", "name": "Western Power Distribution"},
    "15": {"id": "NEEB", "name": "Northern Powergrid (Northeast)"},
    "16": {"id": "NORW", "name": "Electricity North West"},
    "17": {"id": "HYDE", "name": "SSE (Scottish Hydro Electric)"},
    "18": {"id": "SPOW", "name": "SP Energy Networks"},
    "19": {"id": "SEEB", "name": "UK Power Networks"},
    "20": {"id": "SOUT", "name": "SSE (Southern Electric)"},
    "21": {"id": "SWAE", "name": "Western Power Distribution"},
    "22": {"id": "SWEB", "name": "Western Power Distribution"},
    "23": {"id": "YELG", "name": "Northern Powergrid (Yorkshire)"},
    "24": {"id": "IPNL", "name": "Independent Power Networks Ltd."},
    "25": {"id": "LENG", "name": "ESP Electricity"},
    "26": {"id": "GUCL", "name": "Last Mile Electricity"},
    "27": {"id": "ETCL", "name": "The Electricity Network Company Ltd."},
    "28": {"id": "EDFI", "name": "UK Power Networks"},
    "29": {"id": "HARL", "name": "Harlaxton Energy Networks Ltd."},
    "30": {"id": "PENL", "name": "Leep Electricity Networks Ltd."},
    "31": {"id": "UKPD", "name": "UK Power Distribution Ltd."},
    "32": {"id": "UDNL", "name": "Energy Assets Networks Ltd."},
    "33": {"id": "GGEN", "name": "Eclipse Power Networks"},
    "34": {"id": "MPDL", "name": "Murphy Power"},
    "35": {"id": "FEAL", "name": "Fulcrum Electricity Assets"},
    "36": {"id": "VATT", "name": "Vattenfall Networks Ltd."},
    "37": {"id": "FORB", "name": "Optimal Power Networks Ltd."},
    "38": {"id": "INDI", "name": "Indigo Power Limited"},
}

GSP_IDS = {
    "EELC": [("_A", (datetime.date(1996, 4, 1), None))],
    "ETCL": [
        ("_A", (datetime.date(2006, 9, 1), None)),
        ("_B", (datetime.date(2006, 9, 1), None)),
        ("_C", (datetime.date(2006, 9, 1), None)),
        ("_D", (datetime.date(2006, 9, 1), None)),
        ("_E", (datetime.date(2006, 9, 1), None)),
        ("_F", (datetime.date(2006, 9, 1), None)),
        ("_G", (datetime.date(2006, 9, 1), None)),
        ("_H", (datetime.date(2006, 9, 1), None)),
        ("_J", (datetime.date(2006, 9, 1), None)),
        ("_K", (datetime.date(2006, 9, 1), None)),
        ("_L", (datetime.date(2006, 9, 1), None)),
        ("_M", (datetime.date(2006, 9, 1), None)),
        ("_N", (datetime.date(2006, 9, 1), None)),
        ("_P", (datetime.date(2006, 9, 1), None)),
    ],
    "FEAL": [
        ("_A", (datetime.date(2018, 2, 14), None)),
        ("_B", (datetime.date(2018, 2, 14), None)),
        ("_C", (datetime.date(2018, 2, 14), None)),
        ("_D", (datetime.date(2018, 2, 14), None)),
        ("_E", (datetime.date(2018, 2, 14), None)),
        ("_F", (datetime.date(2018, 2, 14), None)),
        ("_G", (datetime.date(2018, 2, 14), None)),
        ("_H", (datetime.date(2018, 2, 14), None)),
        ("_J", (datetime.date(2018, 2, 14), None)),
        ("_K", (datetime.date(2018, 2, 14), None)),
        ("_L", (datetime.date(2018, 2, 14), None)),
        ("_M", (datetime.date(2018, 2, 14), None)),
        ("_N", (datetime.date(2018, 2, 14), None)),
        ("_P", (datetime.date(2018, 2, 14), None)),
    ],
    "FORB": [
        ("_A", (datetime.date(2020, 1, 22), None)),
        ("_B", (datetime.date(2020, 1, 22), None)),
        ("_C", (datetime.date(2020, 1, 22), None)),
        ("_D", (datetime.date(2020, 1, 22), None)),
        ("_E", (datetime.date(2020, 1, 22), None)),
        ("_F", (datetime.date(2020, 1, 22), None)),
        ("_G", (datetime.date(2020, 1, 22), None)),
        ("_H", (datetime.date(2020, 1, 22), None)),
        ("_J", (datetime.date(2020, 1, 22), None)),
        ("_K", (datetime.date(2020, 1, 22), None)),
        ("_L", (datetime.date(2020, 1, 22), None)),
        ("_M", (datetime.date(2020, 1, 22), None)),
        ("_N", (datetime.date(2020, 1, 22), None)),
        ("_P", (datetime.date(2020, 1, 22), None)),
    ],
    "GGEN": [
        ("_A", (datetime.date(2017, 11, 15), None)),
        ("_B", (datetime.date(2017, 11, 15), None)),
        ("_C", (datetime.date(2017, 11, 15), None)),
        ("_D", (datetime.date(2017, 11, 15), None)),
        ("_E", (datetime.date(2017, 11, 15), None)),
        ("_F", (datetime.date(2017, 11, 15), None)),
        ("_G", (datetime.date(2017, 11, 15), None)),
        ("_H", (datetime.date(2017, 11, 15), None)),
        ("_J", (datetime.date(2017, 11, 15), None)),
        ("_K", (datetime.date(2017, 11, 15), None)),
        ("_L", (datetime.date(2017, 11, 15), None)),
        ("_M", (datetime.date(2017, 11, 15), None)),
        ("_N", (datetime.date(2017, 11, 15), None)),
        ("_P", (datetime.date(2017, 11, 15), None)),
    ],
    "GUCL": [
        ("_A", (datetime.date(2005, 8, 12), None)),
        ("_B", (datetime.date(2005, 8, 12), None)),
        ("_C", (datetime.date(2005, 8, 12), None)),
        ("_D", (datetime.date(2005, 8, 12), None)),
        ("_E", (datetime.date(2005, 8, 12), None)),
        ("_F", (datetime.date(2005, 8, 12), None)),
        ("_G", (datetime.date(2005, 8, 12), None)),
        ("_H", (datetime.date(2005, 8, 12), None)),
        ("_J", (datetime.date(2005, 8, 12), None)),
        ("_K", (datetime.date(2005, 8, 12), None)),
        ("_L", (datetime.date(2005, 8, 12), None)),
        ("_M", (datetime.date(2005, 8, 12), None)),
        ("_N", (datetime.date(2005, 8, 12), None)),
        ("_P", (datetime.date(2005, 8, 12), None)),
    ],
    "HARL": [
        ("_A", (datetime.date(2014, 9, 17), None)),
        ("_B", (datetime.date(2014, 9, 17), None)),
        ("_C", (datetime.date(2014, 9, 17), None)),
        ("_D", (datetime.date(2014, 9, 17), None)),
        ("_E", (datetime.date(2014, 9, 17), None)),
        ("_F", (datetime.date(2014, 9, 17), None)),
        ("_G", (datetime.date(2014, 9, 17), None)),
        ("_H", (datetime.date(2014, 9, 17), None)),
        ("_J", (datetime.date(2014, 9, 17), None)),
        ("_K", (datetime.date(2014, 9, 17), None)),
        ("_L", (datetime.date(2014, 9, 17), None)),
        ("_M", (datetime.date(2014, 9, 17), None)),
        ("_N", (datetime.date(2014, 9, 17), None)),
        ("_P", (datetime.date(2014, 9, 17), None)),
    ],
    "INDI": [
        ("_A", (datetime.date(2020, 9, 16), None)),
        ("_B", (datetime.date(2020, 9, 16), None)),
        ("_C", (datetime.date(2020, 9, 16), None)),
        ("_D", (datetime.date(2020, 9, 16), None)),
        ("_E", (datetime.date(2020, 9, 16), None)),
        ("_F", (datetime.date(2020, 9, 16), None)),
        ("_G", (datetime.date(2020, 9, 16), None)),
        ("_H", (datetime.date(2020, 9, 16), None)),
        ("_J", (datetime.date(2020, 9, 16), None)),
        ("_K", (datetime.date(2020, 9, 16), None)),
        ("_L", (datetime.date(2020, 9, 16), None)),
        ("_M", (datetime.date(2020, 9, 16), None)),
        ("_N", (datetime.date(2020, 9, 16), None)),
        ("_P", (datetime.date(2020, 9, 16), None)),
    ],
    "IPNL": [
        ("_A", (datetime.date(2004, 8, 1), None)),
        ("_B", (datetime.date(2004, 8, 1), None)),
        ("_C", (datetime.date(2004, 8, 1), None)),
        ("_D", (datetime.date(2004, 8, 1), None)),
        ("_E", (datetime.date(2004, 8, 1), None)),
        ("_F", (datetime.date(2004, 8, 1), None)),
        ("_G", (datetime.date(2004, 8, 1), None)),
        ("_H", (datetime.date(2004, 8, 1), None)),
        ("_J", (datetime.date(2004, 8, 1), None)),
        ("_K", (datetime.date(2004, 8, 1), None)),
        ("_L", (datetime.date(2004, 8, 1), None)),
        ("_M", (datetime.date(2004, 8, 1), None)),
        ("_N", (datetime.date(2004, 8, 1), None)),
        ("_P", (datetime.date(2004, 8, 1), None)),
    ],
    "LENG": [
        ("_A", (datetime.date(2006, 3, 24), None)),
        ("_B", (datetime.date(2008, 10, 7), None)),
        ("_C", (datetime.date(2005, 4, 1), None)),
        ("_D", (datetime.date(2008, 10, 7), None)),
        ("_E", (datetime.date(2008, 10, 7), None)),
        ("_F", (datetime.date(2008, 10, 7), None)),
        ("_G", (datetime.date(2008, 10, 7), None)),
        ("_H", (datetime.date(2008, 10, 7), None)),
        ("_J", (datetime.date(2008, 10, 7), None)),
        ("_K", (datetime.date(2008, 10, 7), None)),
        ("_L", (datetime.date(2008, 10, 7), None)),
        ("_M", (datetime.date(2008, 10, 7), None)),
        ("_N", (datetime.date(2008, 10, 7), None)),
        ("_P", (datetime.date(2008, 10, 7), None)),
    ],
    "MPDL": [
        ("_A", (datetime.date(2019, 4, 17), None)),
        ("_B", (datetime.date(2019, 4, 17), None)),
        ("_C", (datetime.date(2019, 4, 17), None)),
        ("_D", (datetime.date(2019, 4, 17), None)),
        ("_E", (datetime.date(2019, 4, 17), None)),
        ("_F", (datetime.date(2019, 4, 17), None)),
        ("_G", (datetime.date(2019, 4, 17), None)),
        ("_H", (datetime.date(2019, 4, 17), None)),
        ("_J", (datetime.date(2019, 4, 17), None)),
        ("_K", (datetime.date(2019, 4, 17), None)),
        ("_L", (datetime.date(2019, 4, 17), None)),
        ("_M", (datetime.date(2019, 4, 17), None)),
        ("_N", (datetime.date(2019, 4, 17), None)),
        ("_P", (datetime.date(2019, 4, 17), None)),
    ],
    "PENL": [
        ("_A", (datetime.date(2015, 6, 17), None)),
        ("_B", (datetime.date(2015, 6, 17), None)),
        ("_C", (datetime.date(2015, 6, 17), None)),
        ("_D", (datetime.date(2015, 6, 17), None)),
        ("_E", (datetime.date(2015, 6, 17), None)),
        ("_F", (datetime.date(2015, 6, 17), None)),
        ("_G", (datetime.date(2015, 6, 17), None)),
        ("_H", (datetime.date(2015, 6, 17), None)),
        ("_J", (datetime.date(2015, 6, 17), None)),
        ("_K", (datetime.date(2015, 6, 17), None)),
        ("_L", (datetime.date(2015, 6, 17), None)),
        ("_M", (datetime.date(2015, 6, 17), None)),
        ("_N", (datetime.date(2015, 6, 17), None)),
        ("_P", (datetime.date(2015, 6, 17), None)),
    ],
    "SOUT": [
        ("_A", (datetime.date(2004, 1, 23), None)),
        ("_B", (datetime.date(2004, 1, 23), None)),
        ("_C", (datetime.date(2004, 1, 23), None)),
        ("_D", (datetime.date(2006, 3, 3), None)),
        ("_E", (datetime.date(2004, 1, 23), None)),
        ("_F", (datetime.date(2004, 1, 23), None)),
        ("_G", (datetime.date(2004, 1, 23), None)),
        ("_H", (datetime.date(1996, 4, 1), None)),
        ("_J", (datetime.date(2006, 2, 10), None)),
        ("_K", (datetime.date(2006, 3, 3), None)),
        ("_L", (datetime.date(2006, 7, 28), None)),
        ("_M", (datetime.date(2005, 7, 8), None)),
    ],
    "UDNL": [
        ("_A", (datetime.date(2017, 4, 19), None)),
        ("_B", (datetime.date(2017, 4, 19), None)),
        ("_C", (datetime.date(2017, 4, 19), None)),
        ("_D", (datetime.date(2017, 12, 20), None)),
        ("_E", (datetime.date(2017, 4, 19), None)),
        ("_F", (datetime.date(2017, 12, 20), None)),
        ("_G", (datetime.date(2017, 12, 20), None)),
        ("_H", (datetime.date(2017, 4, 19), None)),
        ("_J", (datetime.date(2017, 4, 19), None)),
        ("_K", (datetime.date(2017, 4, 19), None)),
        ("_L", (datetime.date(2017, 4, 19), None)),
        ("_M", (datetime.date(2017, 12, 20), None)),
        ("_N", (datetime.date(2017, 12, 20), None)),
        ("_P", (datetime.date(2017, 12, 20), None)),
    ],
    "UKPD": [
        ("_A", (datetime.date(2016, 6, 15), None)),
        ("_B", (datetime.date(2016, 6, 15), None)),
        ("_C", (datetime.date(2019, 2, 20), None)),
        ("_D", (datetime.date(2016, 6, 15), None)),
        ("_E", (datetime.date(2016, 6, 15), None)),
        ("_F", (datetime.date(2016, 6, 15), None)),
        ("_G", (datetime.date(2016, 6, 15), None)),
        ("_H", (datetime.date(2016, 6, 15), None)),
        ("_J", (datetime.date(2016, 6, 15), None)),
        ("_K", (datetime.date(2020, 11, 18), None)),
        ("_L", (datetime.date(2020, 11, 18), None)),
        ("_M", (datetime.date(2016, 6, 15), None)),
        ("_N", (datetime.date(2020, 11, 18), None)),
    ],
    "VATT": [
        ("_A", (datetime.date(2019, 1, 23), None)),
        ("_B", (datetime.date(2019, 1, 23), None)),
        ("_C", (datetime.date(2019, 1, 23), None)),
        ("_D", (datetime.date(2019, 1, 23), None)),
        ("_E", (datetime.date(2019, 1, 23), None)),
        ("_F", (datetime.date(2019, 1, 23), None)),
        ("_G", (datetime.date(2019, 1, 23), None)),
        ("_H", (datetime.date(2019, 1, 23), None)),
        ("_J", (datetime.date(2019, 1, 23), None)),
        ("_K", (datetime.date(2019, 1, 23), None)),
        ("_L", (datetime.date(2019, 1, 23), None)),
        ("_M", (datetime.date(2019, 1, 23), None)),
        ("_N", (datetime.date(2019, 1, 23), None)),
        ("_P", (datetime.date(2019, 1, 23), None)),
    ],
    "EMEB": [("_B", (datetime.date(1996, 4, 1), None))],
    "EDFI": [
        ("_C", (datetime.date(2009, 4, 16), datetime.date(2014, 12, 17)))
    ],
    "LOND": [("_C", (datetime.date(1996, 4, 1), None))],
    "MANW": [("_D", (datetime.date(1996, 4, 1), None))],
    "MIDE": [("_E", (datetime.date(1996, 4, 1), None))],
    "NEEB": [("_F", (datetime.date(1996, 4, 1), None))],
    "NORW": [("_G", (datetime.date(1996, 4, 1), None))],
    "SEEB": [("_J", (datetime.date(1996, 4, 1), None))],
    "SWAE": [("_K", (datetime.date(1996, 4, 1), None))],
    "SWEB": [("_L", (datetime.date(1996, 4, 1), None))],
    "YELG": [("_M", (datetime.date(1996, 4, 1), None))],
    "HYDE": [
        ("_N", (datetime.date(2004, 7, 9), None)),
        ("_P", (datetime.date(1996, 4, 1), None)),
    ],
    "SPOW": [("_N", (datetime.date(1996, 4, 1), None))],
}
